/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified for PIX 1998 Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"PICSLICE.H"

extern int	loadPIXfile( picsliceinfo* );
extern int	drawPIX( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );
extern void	psierr( char*, int );


GVIEW *
GV_Load_Pix( fname )
char	*fname;
{
	char	format[]= "PIX";
	picsliceinfo	psi;
	GVIEW	*gp;
	int	ret;

	if( (psi.filehandle= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}
	if( ( ret= loadPIXfile( &psi ) ) != PICSLICE_NORMAL ){
		psierr( format, ret );
		return	NULL;
	}
	if( !(gp= GV_Alloc( psi.width, psi.height, WindowAttrGraphic16,
						fname, NULL, 0 )) ){
		EndOfDraw( &psi );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	(unsigned short*)psi.chainbuf= gp->buf;
	if( ( ret= drawPIX( &psi ) ) != PICSLICE_TERMINATE ){
		psierr( format, ret );
		MFREE( gp );
		return	NULL;
	}else {
		unsigned short	*str= gp->palet,
				*ptr= psi.colortable;
		int	i;
		for( i= 0; i< 16; i++ ){
			*str++= *ptr++;
		}
	}
	return gp;
}
